(function () {
  'use strict';
  // Source: src/html/scripts/tour-sales/module.js
  angular.module('tour-sales', [
    'ui.router',
    'tours',
    'ui.bootstrap'
  ]);
  angular.module('sightseeing-sales', [
    'ui.router',
    'tours',
    'ui.bootstrap'
  ]);
  angular.module('vo-sales', [
    'ui.router',
    'tours',
    'ui.bootstrap',
    'htmlToPdfSave',
    'updateMeta'
  ]);
  angular.module('cruise-sales', [
    'ui.router',
    'tours',
    'ui.bootstrap'
  ]);
  angular.module('clubmed-sales', [
    'ui.router',
    'tours',
    'ui.bootstrap'
  ]);
  angular.module('omra-sales', [
    'ui.router',
    'tours',
    'ui.bootstrap'
  ]);
  angular.module('tours', ['ui.bootstrap']);
  // Source: src/html/scripts/tour-sales/controllers/search-form.js
  angular.module('tours').controller('tours_SearchFormCtrl', [
    '$scope',
    '$location',
    '$window',
    'settings',
    '$log',
    '$http',
    '$state',
    function ($scope, $location, $window, settings, $log, $http, $state) {
      // $log.debug('toursSearchFormCtrl init', settings);
      $scope.setting = settings;
      /* Converts an object into a key/value par with an optional prefix. Used for converting objects to a query string */
      var metaRouter = {};
      metaRouter.go = function (target, opts) {
        opts = opts || {};
        var route = settings.routes[target];
        if (!route) {
          throw new Error('Unknown route ' + target);
        }
        if (route.type === 'redirect') {
          var href = route.href.replace(':path', opts.path || '');
          href = href.replace(':query', qs(opts.query) || '');
          $log.debug('redirect', href);
          $window.location.href = href;
        } else if (route.type === 'state') {
          $state.go(route.name, opts);
        }
      };
      var qs = function (obj, prefix) {
        var str = [];
        for (var p in obj) {
          var k = prefix ? prefix + '[' + p + ']' : p, v = obj[k];
          str.push(angular.isObject(v) ? qs(v, k) : k + '=' + encodeURIComponent(v));
        }
        return str.join('&');
      };
      function themes(q) {
      }
      function langs(q) {
        var url = settings.tours.langAutocomplete.replace(':term', q);
        return $http.get(url).then(function (response) {
          return response.data;
        });
      }
      /**
         * returns autocomple result promise
         */
      function localities(q) {
        var url = settings.tours.localitiesAutocomplete.replace(':term', q);
        return $http.get(url).then(function (response) {
          $log.debug(response);
          return response.data;
        });
      }
      function countries(q) {
        var url = settings.tours.countriesAutocomplete.replace(':term', q);
        return $http.get(url).then(function (response) {
          $log.debug(response);
          return response.data;
        });
      }
      function submit() {
        $log.info('in_submit', $scope.query);
        var params = angular.extend({}, $scope.query);
        console.log('submit', $scope.query);
        if (params.from) {
          params.from = moment(params.from).format('YYYY-MM-DD');
          //var futureMonthPlus = moment(params.from).add(1, 'M');
          //params.to = moment(futureMonthPlus).endOf('month').format('YYYY-MM-DD');
          // params.to = moment(params.from).add(60, 'days').format('YYYY-MM-DD');
          params.to = moment(params.to).format('YYYY-MM-DD');
        }
        /*if (params.to) {
                var futureMonthPlus = moment(params.from).add(1, 'M');
                params.to = moment(futureMonthPlus).endOf('month').format('YYYY-MM-DD');
            }*/
        if (params.departure) {
          params.departure = params.departure.code;
        }
        if (params.vcity) {
          params.vcity = params.vcity.code;
        }
        if (params.b2bdep && params.b2bdep.code != undefined) {
          params.departure = params.b2bdep.code;
          params.depname = params.b2bdep.name;
        }
        if (params.theme) {
          params.theme = params.theme;  // will search by code
        }
        /*if (params.theme.toLowerCase() == 'tout')
                delete params.theme;
            */
        if (params.country) {
          params.country = params.country.code + ':' + params.country.name;  // will search by code
        }
        params.type = settings.templates.type;
        params.lang = params.lang.code ? params.lang.code : 'fr';
        metaRouter.go('search', params);
      }
      $window.onload = function () {
        // console.log("windows location", $window.location);
        $scope.holderVar = $location.search();
        // console.log('location search', $location.search(), $scope.holderVar);
        var length = Object.keys($location.search());
        if (length > 0) {
          var params = {
              type: $location.search().type,
              from: $location.search().from,
              to: $location.search().to,
              lang: $location.search().lang || 'fr'
            };
        } else if (length == 0) {
          var params = {
              type: settings.templates.type,
              lang: 'fr',
              from: moment().format('YYYY-MM-DD')
            };
          // params.to = moment(params.from).add(30, 'days').format('YYYY-MM-DD');
          params.to = moment(params.from).add(3, 'M').format('YYYY-MM-DD');
        }
        metaRouter.go('search', params);
      };
      $scope.$watch('query.from', function (fresh, old) {
        // console.log('fresh, old', fresh, old);
        // console.log('fresh, old', $scope.query.from, $scope.query.to);
        if (fresh === old)
          return;
        var min = moment(fresh).add(1, 'days');
        var to = moment($scope.query.to || 'invalid');
        if (to.isValid() && to.isBefore(min)) {
          $scope.query.to = min.toDate();
        }
        $scope.options.minEndDate = min.toDate();
        $scope.options.minEndMonth = moment(min).startOf('month').toDate();
      });
      /* $http.get(settings.tours.themesAutocomplete.replace(':term', '')).then(function (response) {
                 $scope.options.themes = response.data;
             });*/
      function toggleCalendar($event, cal) {
        $event.preventDefault();
        $event.stopPropagation();
        angular.forEach($scope.calendarsOpen, function (value, key) {
          // close others
          $scope.calendarsOpen[key] = false;
        });
        $scope.calendarsOpen[cal] = !$scope.calendarsOpen[cal];
      }
      angular.extend($scope, {
        themes: themes,
        langs: langs,
        localities: localities,
        submit: submit,
        toggleCalendar: toggleCalendar,
        calendarsOpen: {},
        countries: countries,
        options: {
          minStartDate: moment().startOf('day').toDate(),
          minEndDate: moment().add(1, 'days').startOf('day').toDate(),
          minEndMonth: moment().add(1, 'days').startOf('month').toDate(),
          datepickerTo: { initDate: '$parent.$parent.options.minEndDate' },
          langs: settings.default.langs,
          b2bdep: settings.default.b2bdep,
          themes: settings.default.themes,
          countries: settings.default.countries || []
        }
      });
      $scope.destOps = [];
      var countries = $scope.options.countries;
      $scope.destOps.push({
        label: 'Destination',
        value: {
          'code': 'DestinationCode',
          'name': 'DestinationName'
        }
      });
      for (var i = 0; i <= countries.length; i++) {
        if (countries[i]) {
          var o = {
              label: countries[i].name,
              value: countries[i]
            };
          $scope.destOps.push(o);
        }
      }
      $scope.destSelection = $scope.destOps[0].value;
      $scope.themeOps = [];
      var themes = $scope.options.themes;
      $scope.themeOps.push({
        label: 'Th\xe8me',
        value: 'Th\xe8me'
      });
      for (var i = 0; i <= themes.length; i++) {
        if (themes[i]) {
          var o = {
              label: themes[i].name,
              value: themes[i].name
            };
          $scope.themeOps.push(o);
        }
      }
      $scope.themeSelection = $scope.themeOps[0].value;
      if ($scope.query.country) {
        $scope.destSelection = $scope.query.country;
      }
      if ($scope.query.theme) {
        $scope.themeSelection = $scope.query.theme;
      }
      $scope.$watch('destSelection', function (newVal) {
        // console.log('destSelection newVal', newVal)
        if (newVal.code !== 'DestinationCode')
          $scope.query.country = newVal;
      });
      $scope.$watch('themeSelection', function (newVal) {
        // console.log('themeSelection newVal', newVal)
        if (newVal !== 'Th\xe8me')
          $scope.query.theme = newVal;
      });
    }
  ]);
  ;
  angular.module('ui.bootstrap.datepicker').controller('DatepickerController', [
    '$scope',
    '$attrs',
    '$parse',
    '$interpolate',
    '$timeout',
    '$log',
    'dateFilter',
    'datepickerConfig',
    function ($scope, $attrs, $parse, $interpolate, $timeout, $log, dateFilter, datepickerConfig) {
      datepickerConfig.showWeeks = false;
      var self = this, ngModelCtrl = { $setViewValue: angular.noop };
      // nullModelCtrl;
      // Modes chain
      this.modes = [
        'day',
        'month',
        'year'
      ];
      // Configuration attributes
      angular.forEach([
        'formatDay',
        'formatMonth',
        'formatYear',
        'formatDayHeader',
        'formatDayTitle',
        'formatMonthTitle',
        'minMode',
        'maxMode',
        'showWeeks',
        'startingDay',
        'yearRange'
      ], function (key, index) {
        self[key] = angular.isDefined($attrs[key]) ? index < 8 ? $interpolate($attrs[key])($scope.$parent) : $scope.$parent.$eval($attrs[key]) : datepickerConfig[key];
      });
      // Watchable date attributes
      angular.forEach([
        'minDate',
        'maxDate'
      ], function (key) {
        if ($attrs[key]) {
          $scope.$parent.$watch($parse($attrs[key]), function (value) {
            self[key] = value ? new Date(value) : null;
            self.refreshView();
          });
        } else {
          self[key] = datepickerConfig[key] ? new Date(datepickerConfig[key]) : null;
        }
      });
      if (angular.isDefined($attrs.initDate)) {
        $scope.$parent.$watch($parse($attrs.initDate), function (value) {
          if (!ngModelCtrl.$modelValue) {
            self.activeDate = value ? new Date(value) : new Date();
            self.refreshView();
          }
        });
      }
      $scope.datepickerMode = $scope.datepickerMode || datepickerConfig.datepickerMode;
      $scope.uniqueId = 'datepicker-' + $scope.$id + '-' + Math.floor(Math.random() * 10000);
      this.activeDate = angular.isDefined($attrs.initDate) ? $scope.$parent.$eval($attrs.initDate) : new Date();
      $scope.isActive = function (dateObject) {
        if (self.compare(dateObject.date, self.activeDate) === 0) {
          $scope.activeDateId = dateObject.uid;
          return true;
        }
        return false;
      };
      this.init = function (ngModelCtrl_) {
        ngModelCtrl = ngModelCtrl_;
        ngModelCtrl.$render = function () {
          self.render();
        };
      };
      this.render = function () {
        if (ngModelCtrl.$modelValue) {
          var date = new Date(ngModelCtrl.$modelValue), isValid = !isNaN(date);
          if (isValid) {
            this.activeDate = date;
          } else {
            $log.error('Datepicker directive: "ng-model" value must be a Date object, a number of milliseconds since 01.01.1970 or a string representing an RFC2822 or ISO 8601 date.');
          }
          ngModelCtrl.$setValidity('date', isValid);
        }
        this.refreshView();
      };
      this.refreshView = function () {
        if (this.element) {
          this._refreshView();
          var date = ngModelCtrl.$modelValue ? new Date(ngModelCtrl.$modelValue) : null;
          ngModelCtrl.$setValidity('date-disabled', !date || this.element && !this.isDisabled(date));
        }
      };
      this.createDateObject = function (date, format) {
        var model = ngModelCtrl.$modelValue ? new Date(ngModelCtrl.$modelValue) : null;
        return {
          date: date,
          label: dateFilter(date, format),
          selected: model && this.compare(date, model) === 0,
          disabled: this.isDisabled(date),
          current: this.compare(date, new Date()) === 0
        };
      };
      this.isDisabled = function (date) {
        return this.minDate && this.compare(date, this.minDate) < 0 || this.maxDate && this.compare(date, this.maxDate) > 0 || $attrs.dateDisabled && $scope.dateDisabled({
          date: date,
          mode: $scope.datepickerMode
        });
      };
      // Split array into smaller arrays
      this.split = function (arr, size) {
        var arrays = [];
        while (arr.length > 0) {
          arrays.push(arr.splice(0, size));
        }
        return arrays;
      };
      $scope.select = function (date) {
        if ($scope.datepickerMode === self.minMode) {
          var dt = ngModelCtrl.$modelValue ? new Date(ngModelCtrl.$modelValue) : new Date(0, 0, 0, 0, 0, 0, 0);
          dt.setFullYear(date.getFullYear(), date.getMonth(), date.getDate());
          ngModelCtrl.$setViewValue(dt);
          ngModelCtrl.$render();
        } else {
          self.activeDate = date;
          $scope.datepickerMode = self.modes[self.modes.indexOf($scope.datepickerMode) - 1];
        }
      };
      $scope.move = function (direction) {
        var year = self.activeDate.getFullYear() + direction * (self.step.years || 0), month = self.activeDate.getMonth() + direction * (self.step.months || 0);
        self.activeDate.setFullYear(year, month, 1);
        self.refreshView();
      };
      $scope.toggleMode = function (direction) {
        direction = direction || 1;
        if ($scope.datepickerMode === self.maxMode && direction === 1 || $scope.datepickerMode === self.minMode && direction === -1) {
          return;
        }
        $scope.datepickerMode = self.modes[self.modes.indexOf($scope.datepickerMode) + direction];
      };
      // Key event mapper
      $scope.keys = {
        13: 'enter',
        32: 'space',
        33: 'pageup',
        34: 'pagedown',
        35: 'end',
        36: 'home',
        37: 'left',
        38: 'up',
        39: 'right',
        40: 'down'
      };
      var focusElement = function () {
        $timeout(function () {
          self.element[0].focus();
        }, 0, false);
      };
      // Listen for focus requests from popup directive
      $scope.$on('datepicker.focus', focusElement);
      $scope.keydown = function (evt) {
        var key = $scope.keys[evt.which];
        if (!key || evt.shiftKey || evt.altKey) {
          return;
        }
        evt.preventDefault();
        evt.stopPropagation();
        if (key === 'enter' || key === 'space') {
          if (self.isDisabled(self.activeDate)) {
            return;  // do nothing
          }
          $scope.select(self.activeDate);
          focusElement();
        } else if (evt.ctrlKey && (key === 'up' || key === 'down')) {
          $scope.toggleMode(key === 'up' ? 1 : -1);
          focusElement();
        } else {
          self.handleKeyDown(key, evt);
          self.refreshView();
        }
      };
    }
  ]);  /*
        //http://outgoing.fractalite.com/tours?from=2016-07-01&lang=fr&limit=100&qt=search&skip=0&to=2016-09-30&type=vo
        /*function initSearch() {


            var params = {
                type: settings.templates.type,
                from: $scope.query.from ? moment($scope.query.from).format('YYYY-MM-DD') : moment().format('YYYY-MM-DD')
            };

            params.to = moment(params.from).add(30, 'days').format('YYYY-MM-DD');
            // params.to = moment(futureMonthPlus).endOf('month').format('YYYY-MM-DD');

            console.log('initSearch just called', params);

            metaRouter.go('search', params);
        }


        */
}());