(function () {
  'use strict';
  // Source: src/html/scripts/travel-sales/app.js
  angular.module('travel-sales', [
    'ui.router',
    'travel'
  ]);
  angular.module('travel', [
    'ui.router',
    'hc.marked',
    'ui.bootstrap',
    'angulartics',
    'angulartics.google.analytics'
  ]);
  // Source: src/html/scripts/travel-sales/config/analytics.js
  angular.module('travel').config([
    '$analyticsProvider',
    function ($analyticsProvider) {
      //$analyticsProvider.firstPageview(true)
      $analyticsProvider.withAutoBase(true);  /* Records full path */
    }
  ]);
  // Source: src/html/scripts/travel-sales/config/states.js
  /*
var loc = window.location.href;
if (loc.indexOf("#") !== loc.indexOf("#!") ){
  window.location.href = loc.replace("#", "#!");
}
*/
  angular.module('travel-sales').config([
    '$sceProvider',
    '$stateProvider',
    '$urlRouterProvider',
    '$httpProvider',
    '$locationProvider',
    'settings',
    function ($sceProvider, $stateProvider, $urlRouterProvider, $httpProvider, $locationProvider, settings) {
      $locationProvider.hashPrefix('!');
      function httpResolved(res) {
        return res.data;
      }
      var statesSeo = {
          search: { url: '/?country&destination&period&theme&budget' },
          searchByType: { url: '/:family?country&destination&period&theme&budget' },
          searchInCountry: { url: '/:country?&family&destination&period&theme&budget' },
          view: { url: '/:countries/:name,:travel' }
        };
      $stateProvider.state('search', {
        url: statesSeo.search.url,
        templateUrl: 'hermes-travel-search',
        controller: 'travel_SearchCtrl',
        resolve: {
          options: [
            '$http',
            '$q',
            function ($http, $q) {
              var opts = {};
              // TODO error handling ?
              opts.themes = $http.get('/themes?skip=0&limit=1000').then(httpResolved);
              opts.countries = $http.get('/countries?qt=index&skip=0&limit=1000').then(httpResolved);
              opts.destinations = $http.get('/destinations?skip=0&limit=1000').then(httpResolved);
              opts.families = settings.travels.families;
              opts.types = settings.travels.types;
              return $q.all(opts);
            }
          ]
        }
      }).state('view', {
        url: statesSeo.view.url,
        templateUrl: 'hermes-travel-view',
        controller: 'travel_ViewCtrl'
      }).state('searchByType', {
        url: '/:family?country&destination&period&theme&budget',
        templateUrl: 'hermes-travel-search',
        controller: 'travel_SearchCtrl',
        resolve: {
          options: [
            '$http',
            '$q',
            function ($http, $q) {
              var opts = {};
              // TODO error handling ?
              opts.themes = $http.get('/themes?skip=0&limit=1000').then(httpResolved);
              opts.countries = $http.get('/countries?qt=index&skip=0&limit=1000').then(httpResolved);
              opts.destinations = $http.get('/destinations?skip=0&limit=1000').then(httpResolved);
              opts.families = settings.travels.families;
              opts.types = settings.travels.types;
              return $q.all(opts);
            }
          ]
        }
      }).state('agences', {
        url: '/nos-agences',
        templateUrl: 'agences-list',
        controller: 'agencesCtrl'
      });
      $urlRouterProvider.otherwise('/');
      $httpProvider.defaults.headers.common.Accept = 'application/json';
    }
  ]);
  // Source: src/html/scripts/travel-sales/controllers/agences.js
  angular.module('travel').controller('agencesCtrl', [
    '$scope',
    '$http',
    '$log',
    function ($scope, $http, $log) {
      $log.info('in agencesCtrl');
    }
  ]);
  // Source: src/html/scripts/travel-sales/controllers/search-form.js
  angular.module('travel').controller('travels_SearchFormCtrl', [
    '$scope',
    '$http',
    '$window',
    '$location',
    '$log',
    'settings',
    function ($scope, $http, $window, $location, $log, settings) {
      // $log.info('travels_SearchFormCtrl', settings);
      var query = $scope.query;
      $scope.query.travel = $scope.query.travel || {};
      angular.extend($scope, {
        maxAdults: 4,
        maxChildren: 4,
        search: search,
        toggleCalendar: toggleCalendar,
        calendarsOpen: {},
        options: {
          adults: [
            1,
            2,
            3,
            4
          ],
          children: [
            0,
            1,
            2,
            3,
            4
          ],
          ages: [
            1,
            2,
            3,
            4,
            5,
            6,
            7,
            8,
            9,
            10,
            11,
            12
          ],
          durations: [
            5,
            7,
            14,
            15
          ],
          minStartDate: moment().startOf('day').toDate(),
          minEndDate: moment().add(1, 'days').startOf('day').toDate(),
          minEndMonth: moment().add(1, 'days').startOf('month').toDate(),
          datepickerTo: { initDate: '$parent.$parent.options.minEndDate' },
          months: [
            'Janvier',
            'F\xe9rvier',
            'Mars',
            'Avril',
            'Mais',
            'Juin',
            'Juillet',
            'Aout',
            'Septembre',
            'Octobre',
            'Novembre',
            'D\xe9cembre'
          ],
          types: [
            { name: 'Tout' },
            {
              code: 'tour',
              name: 'Circuit'
            },
            {
              code: 'stay',
              name: 'S\xe9jour'
            },
            {
              code: 'club',
              name: 'Club/All Inclusive'
            }
          ],
          vo: {
            countries: settings.vo.default.countries,
            themes: settings.vo.default.themes
          },
          cruise: { countries: settings.cruise.default.countries },
          clubmed: { countries: settings.clubmed.default.countries }
        }
      });
      $scope.query.travel.destination = $scope.options.vo.countries[0];
      $scope.query.travel.from = moment().format('YYYY-MM-DD');
      function search(type) {
        console.log('serach type', type);
        // if ($scope.query.travel.theme.toLowerCase() === 'tout') delete $scope.query.travel.theme;
        if (type === 'OMRA') {
          //from=2018-06-19&to=2018-08-18&lang=fr&type=omra
          var qt = $scope.query.travel;
          // var country = qt.destination.country;
          //var country = qt.destination;
          var q = {
              type: 'OMRA',
              lang: 'fr'
            };
          if (qt.from) {
            q.from = moment(qt.from).format('YYYY-MM-DD');
            // q.to = moment(q.from).add(30, 'days').format('YYYY-MM-DD');
            q.to = moment(q.from).add(2, 'M').format('YYYY-MM-DD');
          }
          var qs = [];
          angular.forEach(q, function (value, key) {
            qs.push(key + '=' + value);
          });
          console.log('$window.location.href', '/ngapps/omra-sales#/?' + qs.join('&'));
          // return ;
          $window.location.href = '/ngapps/omra-sales#/?' + qs.join('&');
        } else if (qt.destination !== undefined) {
          console.log('country variable', qt.destination);
          var qt = $scope.query.travel;
          // var country = qt.destination.country;
          var country = qt.destination;
          var q = {
              country: country.code + ':' + country.name,
              type: qt.type || type || 'vo',
              lang: qt.lang || 'fr'
            };
          if (qt.from) {
            q.from = moment(qt.from).format('YYYY-MM-DD');
            q.to = moment(q.from).add(2, 'M').format('YYYY-MM-DD');  // q.to = moment(q.from).add(60, 'days').format('YYYY-MM-DD');
          }
          if (qt.theme) {
            q.theme = qt.theme;
          }
          var qs = [];
          angular.forEach(q, function (value, key) {
            qs.push(key + '=' + value);
          });
          if ($window.location.pathname === '/voyages') {
            $location.path('/');
            $location.search(q);
          } else {
            if (type === 'VO') {
              $window.location.href = '/ngapps/vo-sales#/?' + qs.join('&');
            } else if (type === 'CLUBMED') {
              $window.location.href = '/ngapps/clubmed-sales#/?' + qs.join('&');
            } else if (type === 'CRUISE') {
              $window.location.href = '/ngapps/cruise-sales#/?' + qs.join('&');
            }
          }
        }
      }
      ;
      function toggleCalendar($event, cal) {
        $event.preventDefault();
        $event.stopPropagation();
        angular.forEach($scope.calendarsOpen, function (value, key) {
          // close others
          $scope.calendarsOpen[key] = false;
        });
        $scope.calendarsOpen[cal] = !$scope.calendarsOpen[cal];
      }
    }
  ]);
  /*$http.get('/destinations', { headers: { 'accept': 'application/json' } }).then(function(res) {
            console.log("destination", res.data);
            $scope.searchDestination = res.data;
            $scope.query.travel = $scope.query.travel || {};
            $scope.query.travel.destination = res.data[0];
            $scope.query.travel.from = moment().format('YYYY-MM-DD');
          });*/
  /* {
  "_id": "53a017df7834cd2885869261",
  "_perms": {
    "r": [
      "*"
    ],
    "w": [
      "g:admin"
    ],
    "d": [
      "g:admin"
    ]
  },
  "country": {
    "code": "TR",
    "name": "Turquie"
  },
  "name": "Istanbul"
}*/
  // after select 
  /*
{
  "code": "TR",
  "name": "Turquie"
}
*/
  // Source: src/html/scripts/travel-sales/controllers/search.js
  angular.module('travel').controller('travel_SearchCtrl', [
    '$scope',
    '$log',
    '$rootScope',
    '$state',
    '$stateParams',
    '$http',
    'options',
    '$location',
    function travel_SearchCtrl($scope, $log, $rootScope, $state, $stateParams, $http, options, $location) {
      //$log.debug('travel_SearchCtrl\n=========');
      var filters = {};
      var query = {};
      var results = [];
      function filter(f, option) {
        $location.search(f.code, option[f.itemCode] || null);
      }
      function findFilterItem(filter, code) {
        var i = filter.items.length;
        while (i--) {
          if (filter.items[i][filter.itemCode] == code) {
            return filter.items[i];
          }
        }
        return false;
      }
      function findCodeNameEntry(code, entries, key) {
        var i = entries.length;
        key = key || 'code';
        while (i--) {
          if (entries[i][key] === code) {
            return entries[i];
          }
        }
        return null;
      }
      function search(more) {
        var q = angular.copy($stateParams);
        q.limit = 20;
        q.qt = 'search';
        if (!more) {
          q.skip = 0;
          results.length = 0;
        } else {
          q.skip = results.length;
        }
        query.skip = q.skip;
        if (q.country) {
          q.country = q.country.toUpperCase();
        }
        //console.log('search',q);
        $scope.status = 'searching';
        $http.get('/travels', { params: q }).then(onSearchResponse, onSearchError);
      }
      function onSearchResponse(res) {
        $scope.status = 'results';
        if (!res.data) {
          if (results.length === 0) {
            $scope.status = 'nocontent';
          }
          return;
        }
        $rootScope.meta = {
          title: 'Voyages organis\xe9s : ' + res.data[0].destinations[0].country.name,
          description: 'Voyages organis\xe9s par Atlas Voyages, destination ' + res.data[0].destinations[0].country.name
        };
        $scope.$emit('pageView', $rootScope.meta);
        angular.forEach(res.data, decode);
        results.push.apply(results, res.data);
        if (results.length < 20) {
          $scope.hasMore = false;
        } else {
          $scope.hasMore = true;
        }
      }
      function decode(item) {
        item.links.view = window.location.pathname + '#!/' + item.links.view;
        if (!item.photos || item.photos.length === 0)
          return;
        var href = item.photos[0].href;
        if (href) {
          item.photos[0].href = href.replace('http://atlasvoyages.s3.amazonaws.com/', '//d38217paua6wkj.cloudfront.net/320x240/');
        }
      }
      function changeDestination() {
        if (query.country) {
          $location.search('country', query.country._id || null);
        }
        if (query.destination) {
          $location.search('destination', query.destination._id || null);
        }
      }
      function onSearchError() {
        $log.error('search returned an error', arguments);
        $scope.status = 'error';
      }
      function buildPeriods() {
        var months = moment.months();
        months = [
          'janvier',
          'f\xe9vrier',
          'mars',
          'avril',
          'mai',
          'juin',
          'juillet',
          'ao\xfbt',
          'septembre',
          'octobre',
          'novembre',
          'd\xe9cembre'
        ];
        var currentMonth = moment().month();
        var ordered = months.slice(currentMonth);
        ordered = ordered.concat(months.slice(undefined, currentMonth));
        var result = [{ label: 'Toutes les p\xe9riodes' }];
        var i = 0;
        while (ordered.length !== 0) {
          result.push({
            code: i,
            label: ordered.shift()
          });
          i++;
        }
        return result;
      }
      function buildBudgets() {
        return [
          { label: 'Tous budgets' },
          {
            code: '0,5000',
            label: 'moins de 5.000 Dh (par pers.)'
          },
          {
            code: '5000,10000',
            label: '5.000 - 10.000 Dh par pers.'
          },
          {
            code: '10000,15000',
            label: '10 000 - 15 000 Dh (par pers.)'
          },
          {
            code: '15000,20000',
            label: '15 000 - 20 000 Dh (par pers.)'
          },
          {
            code: '20000,999999',
            label: 'plus de 20 000 Dh (par pers.)'
          }
        ];
      }
      filters.period = {
        weight: 3,
        label: 'Toutes les p\xe9riodes',
        code: 'period',
        itemLabel: 'label',
        itemCode: 'code',
        items: buildPeriods()
      };
      filters.theme = {
        weight: 2,
        label: 'Tous les th\xe8mes',
        code: 'theme',
        itemLabel: 'name',
        itemCode: '_id',
        items: options.themes
      };
      filters.budget = {
        weight: 4,
        label: 'Tous les budget',
        code: 'budget',
        itemLabel: 'label',
        itemCode: 'code',
        items: buildBudgets()
      };
      //console.log("$stateParams",$stateParams);
      for (var k in filters) {
        query[k] = findFilterItem(filters[k], $stateParams[k]);
      }
      //    console.log(query);
      options.countries.unshift({
        code: null,
        name: 'Tous les pays'
      });
      options.destinations.unshift({
        code: null,
        name: 'Toutes les destinations'
      });
      angular.extend($scope, {
        filters: filters,
        filter: filter,
        search: search,
        context: 'search',
        query: query,
        results: results,
        options: options,
        changeDestination: changeDestination
      });
      if ($stateParams.family) {
        for (var i = 0; i < options.families.length; i++) {
          if (options.families[i].code === $stateParams.family) {
            $scope.family = options.families[i];
            break;
          }
        }
      }
      if ($stateParams.country) {
        //console.log("country" + $stateParams.country);
        query.country = findCodeNameEntry($stateParams.country, options.countries, '_id');  //console.log("country", query.country);
      }
      if ($stateParams.destination) {
        $http.get('/destinations/' + $stateParams.destination).then(function (res) {
          query.destination = res.data;
        });
      }
      search();
    }
  ]);
  // Source: src/html/scripts/travel-sales/controllers/view.js
  angular.module('travel').controller('travel_ViewCtrl', [
    '$scope',
    '$rootScope',
    '$log',
    '$state',
    '$stateParams',
    '$http',
    function travel_SearchCtrl($scope, $rootScope, $log, $state, $stateParams, $http) {
      $log.debug('travel_SearchCtrl\n=========');
      $scope.context = 'travel';
      var request = { children: [] };
      function load() {
        $http.get('/travels/' + $stateParams.travel).then(onSearchResponse, onSearchError);
      }
      function onSearchResponse(res) {
        $scope.status = 'results';
        $log.debug('travel_ViewCtrl', res.data);
        document.title = res.data.name;
        // meta data
        $rootScope.meta = {
          title: res.data.name,
          description: res.data.teaser
        };
        $scope.$emit('pageView', $rootScope.meta);
        angular.forEach(res.data.photos, function (photo) {
          photo.href = photo.href.replace('http://atlasvoyages.s3.amazonaws.com/', '//d38217paua6wkj.cloudfront.net/640x480/');
        });
        $scope.travel = res.data;
        request.product = {
          _id: res.data._id,
          name: res.data.name
        };
        $scope.requestStatus = 'blank';
      }
      function onSearchError() {
        $log.error('search returned an error', arguments);
        $scope.status = 'error';
      }
      function sendReservation() {
        $scope.status = 'saving';
        //$log.debug('request', $scope.request);
        //return;
        $http.post('/travel-product-requests', $scope.request).success(requestSaved).error(requestSaveFailed);
      }
      function requestSaved() {
        $scope.requestStatus = 'success';
        if (window.ga) {
          window.ga('send', 'event', 'voyage', 'demande', $rootScope.meta.title);
        }
      }
      function requestSaveFailed() {
        $scope.requestStatus = 'failed';
      }
      function toggleCalendar() {
      }
      function childCountChanged(count) {
        console.log(request);
        while (request.children.length < count) {
          request.children.push({ age: 0 });
        }
        while (request.children.length > count) {
          request.children.pop();
        }
      }
      load();
      angular.extend($scope, {
        toggleCalendar: toggleCalendar,
        sendReservation: sendReservation,
        childCountChanged: childCountChanged,
        options: { minDeparture: moment().toDate() },
        request: request,
        childCount: 0
      });
    }
  ]);
}());